package com.ruoyi.ems.controller;

import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.ems.domain.AdmOpAlarm;
import com.ruoyi.ems.service.IAdmOpAlarmService;

/**
 * 能源设施告警Controller
 *
 * @author ruoyi
 * @date 2024-08-26
 */
@RestController
@RequestMapping("/alarm-info")
public class AdmOpAlarmController extends BaseController {
    @Autowired
    private IAdmOpAlarmService admOpAlarmService;

    /**
     * 查询能源设施告警列表
     */
    @RequiresPermissions("ems:alarm-info:list")
    @GetMapping("/list")
    public TableDataInfo list(AdmOpAlarm admOpAlarm) {
        startPage();
        List<AdmOpAlarm> list = admOpAlarmService.selectAdmOpAlarmList(admOpAlarm);
        return getDataTable(list);
    }

    /**
     * 导出能源设施告警列表
     */
    @RequiresPermissions("ems:alarm-info:export")
    @Log(title = "能源设施告警", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, AdmOpAlarm admOpAlarm) {
        List<AdmOpAlarm> list = admOpAlarmService.selectAdmOpAlarmList(admOpAlarm);
        ExcelUtil<AdmOpAlarm> util = new ExcelUtil<AdmOpAlarm>(AdmOpAlarm.class);
        util.exportExcel(response, list, "能源设施告警数据");
    }

    /**
     * 获取能源设施告警详细信息
     */
    @RequiresPermissions("ems:alarm-info:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(admOpAlarmService.selectAdmOpAlarmById(id));
    }

    /**
     * 新增能源设施告警
     */
    @RequiresPermissions("ems:alarm-info:add")
    @Log(title = "能源设施告警", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody AdmOpAlarm admOpAlarm) {
        return toAjax(admOpAlarmService.insertAdmOpAlarm(admOpAlarm));
    }

    /**
     * 修改能源设施告警
     */
    @RequiresPermissions("ems:alarm-info:edit")
    @Log(title = "能源设施告警", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody AdmOpAlarm admOpAlarm) {
        return toAjax(admOpAlarmService.updateAdmOpAlarm(admOpAlarm));
    }

    /**
     * 删除能源设施告警
     */
    @RequiresPermissions("ems:alarm-info:remove")
    @Log(title = "能源设施告警", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(admOpAlarmService.deleteAdmOpAlarmByIds(ids));
    }

    @GetMapping("/alarm/type/index")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qryAlarmTypeIndex(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qryAlarmTypeIndex(areaCode));
    }

    @GetMapping("/alarm/type/index/day")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qryAlarmTypeIndexDay(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qryAlarmTypeIndexDay(areaCode));
    }

    @GetMapping("/alarm/type/index/month")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qryAlarmTypeIndexMonth(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qryAlarmTypeIndexMonth(areaCode));
    }

    @GetMapping("/alarm/type/index/year")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qryAlarmTypeIndexYear(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qryAlarmTypeIndexYear(areaCode));
    }

    @GetMapping("/subsys/index/day")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qrySubSysIndexDay(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qrySubSysIndexDay(areaCode));
    }

    @GetMapping("/subsys/index/month")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qrySubSysIndexMonth(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qrySubSysIndexMonth(areaCode));
    }

    @GetMapping("/subsys/index/year")
    @RequiresPermissions("ems:alarm-info:query")
    public AjaxResult qrySubSysIndexYear(@RequestParam("areaCode") String areaCode) {
        return success(admOpAlarmService.qrySubSysIndexYear(areaCode));
    }
}
